  // ComponentClass.h: interface for the CComponentClass class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COMPONENTCLASS_H__5F1978A2_67C1_4AAB_8C12_44790D3700B2__INCLUDED_)
#define AFX_COMPONENTCLASS_H__5F1978A2_67C1_4AAB_8C12_44790D3700B2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MapDefMethod.h"
#include "CodeDecodeFile.h"
#include "paramdefs.h"
#include "AddIn.h"
#include "ModuleString.h"
#include "BLModuleWrapper.h"
#include "OXY_Value.h"
#include "SetOfHierarchy.h"
#include "BaseClassContext.h"

extern CBkEndUI * pBkEndUI;
//typedef class CArray<CBLModule7*,CBLModule7*> CBLModuleArray;

//public CStdOleBLContext  
class CComponentClass : public CBLContext
{
DECLARE_DYNCREATE(CComponentClass);
public:
	static void SetDebugInfo(CComponentClass *pComp);
	static void ClearDebugInfo();
  static bool isExeptionStatus;
  static CString strTextExeption;
  static CValue* ExeptionValue;

	static void GetFullTypeName(CBLContext *pCont, CString& rus, CString& eng);

	inline int ReplaceInstBaseClasses(const CValue &NameClass, const CValue &Instance, CValue &rValue);
	inline int GetBaseClass(const CValue &NameClass, CValue & rValue) const;
	CBLModule * GetModule() const;
	CBLModule * GetPrevModule() const;
	void InvokeConstructor();

	//virtual CBLModuleWrapper* Init(const char* file, CComponentClass* pCreatedCompModule);
  virtual CBLModule* Init(const char* file, CComponentClass* pCreatedCompModule);

	void ShowError(const char *);
	CComponentClass();
	virtual ~CComponentClass();
 
  enum {
  fuctGetBaseClass,
  //procRegObj,
  //procUnRegObj,
  procAssignFriendModule,
  procAddBaseClass,
  funcSendMessageOwnMod,
  funcGetPathName,
  //procBegPostNestedDoc,
  //procEndPostNestedDoc,
  funcGetEnvContext,
  funcGetParamsList,
  funcReplaceInstBaseClasses,
  funcSetOnIndexParams,
  procOnOpen,
  procThrow,
	lastMethod
	};

  static class CMapDefMethod MapDef;
  
  virtual int  CallAsFunc(int,class CValue &,class CValue * *);	//935
	virtual int  CallAsProc(int,class CValue * *);	//937
	virtual void  DecrRef(void);	//1086
	virtual int  FindMethod(char const *)const;	//1366
	virtual int  FindProp(char const *)const;	//1369
	virtual char const *  GetCode(void)const;	//1544
	virtual int  GetDestroyUnRefd(void)const;	//1657
	virtual void  GetExactValue(class CValue &);	//1708
	virtual class CObjID   GetID(void)const;	//1804
	virtual class CBLContextInternalData *  GetInternalData(void);	//1826
	virtual char const *  GetMethodName(int,int)const;	//1964
	virtual int  GetNMethods(void)const;	//2005
	virtual int  GetNParams(int)const;	//2008
	virtual int  GetNProps(void)const;	//2015
	virtual int  GetParamDefValue(int,int,class CValue *)const;	//2122
	virtual char const *  GetPropName(int,int)const;	//2187
	virtual int  GetPropVal(int,class CValue &)const;	//2221
	virtual long  GetTypeID(void)const;	//2505
	virtual char const *  GetTypeString(void)const;	//2513
	virtual class CType   GetValueType(void)const;	//2547
	virtual int  HasRetVal(int)const;	//2657
	virtual void  IncrRef(void);	//2668
	virtual void  InitObject(class CType const &);	//2721
	virtual void  InitObject(char const *);	//2722
	virtual int  IsExactValue(void)const;	//2808
	virtual int  IsOleContext(void)const;	//2846
	virtual int  IsPropReadable(int)const;	//2863
	virtual int  IsPropWritable(int)const;	//2865
	virtual int  IsSerializable(void);	//2874
	virtual int  SaveToString(class CString &);	//3295
	virtual void  SelectByID(class CObjID,long);	//3350
	virtual int  SetPropVal(int,class CValue const &);	//3694
  void SetNestedObj(CBLContext* pCont);
	static class CObjID ObjID;
  
  //CBLModuleWrapper *pMod;
  CBLModule *pMod;
  mutable CMapStringToPtr   m_BindInstaceValueList;
  static void ThrowExeption(bool isThrow = true);
protected:
  
  CBLModule  *pCurModule;
  CBLContext *pDebugContext;
private:		
  friend class CSetOfHierarchy;

	CString m_NameOfInstance;
  list<CBLContext *> vecOfBaseCont;
  typedef list<CBLContext *>::const_iterator CONST_ITER_CONT;
  typedef list<CBLContext *>::iterator ITER_CONT;    
  class CParamDefs *defFnNames;
  struct MethParamsDef 
  {
    int nNumberOfMeth;
    int nRealNumberOfMeth;
    CBLContext* pContext;
  }; 
  mutable MethParamsDef m_MethParamsDef;  
  //unsigned char *pPoint;
  
  inline int CallAsMethod(int iMethNum, CValue * *ppValue, bool bHasRetVal = false, CValue * pRetValue = NULL);
  
  static CComponentClass* m_CurDebugObject;
  bool m_isCreateOptimizeMode;
};

#endif // !defined(AFX_COMPONENTCLASS_H__5F1978A2_67C1_4AAB_8C12_44790D3700B2__INCLUDED_)
